? env.el
? alist.el
cvs server: Diffing .
Index: Makefile
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/Makefile,v
retrieving revision 1.14
diff -u -r1.14 Makefile
--- Makefile	1999/07/26 04:30:10	1.14
+++ Makefile	1999/10/22 05:15:32
@@ -17,15 +17,15 @@
 # the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 # Boston, MA 02111-1307, USA.
 
-VERSION = 1.15
-AUTHOR_VERSION = 9.20
+VERSION = 1.16
+AUTHOR_VERSION = 9.22
 MAINTAINER = XEmacs Development Team <xemacs-beta@xemacs.org>
 PACKAGE = apel
 PKG_TYPE = regular
 REQUIRES = fsf-compat xemacs-base
 CATEGORY = libs
 
-ELCS = broken.elc calist.elc emu.elc filename.elc \
+ELCS = alist.elc broken.elc calist.elc emu.elc filename.elc \
 	install.elc inv-xemacs.elc invisible.elc mcharset.elc mcs-20.elc \
 	mcs-ltn1.elc mule-caesar.elc path-util.elc pccl.elc poe-xemacs.elc \
 	poe.elc poem-ltn1.elc poem-xm.elc poem.elc \
@@ -33,7 +33,7 @@
 	pcustom.elc pces.elc pces-raw.elc pces-20.elc pces-xfc.elc
 
 ## The following files are no longer in net apel, but tm needs them.
-ELCS += std11.elc std11-parse.elc file-detect.elc atype.elc
+ELCS += file-detect.elc atype.elc
 
 EXTRA_SOURCES = README.en
 
Index: atype.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/atype.el,v
retrieving revision 1.3
diff -u -r1.3 atype.el
--- atype.el	1999/07/26 04:30:10	1.3
+++ atype.el	1999/10/22 05:15:33
@@ -3,7 +3,7 @@
 ;; Copyright (C) 1994,1995,1996,1997 Free Software Foundation, Inc.
 
 ;; Author: MORIOKA Tomohiko <morioka@jaist.ac.jp>
-;; Version: $Id: atype.el,v 1.3 1999/07/26 04:30:10 steveb Exp $
+;; Version: $Id: atype.el,v 6.6 1997/03/10 14:11:23 morioka Exp $
 ;; Keywords: atype
 
 ;; This file is part of APEL (A Portable Emacs Library).
@@ -25,7 +25,8 @@
 
 ;;; Code:
 
-(require 'emu)
+(require 'emu)				; for backward compatibility.
+(require 'poe)				; delete.
 (require 'alist)
 
 
Index: file-detect.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/file-detect.el,v
retrieving revision 1.3
diff -u -r1.3 file-detect.el
--- file-detect.el	1999/07/26 04:30:11	1.3
+++ file-detect.el	1999/10/22 05:15:34
@@ -3,7 +3,7 @@
 ;; Copyright (C) 1996,1997 Free Software Foundation, Inc.
 
 ;; Author: MORIOKA Tomohiko <morioka@jaist.ac.jp>
-;; Version: $Id: file-detect.el,v 1.3 1999/07/26 04:30:11 steveb Exp $
+;; Version: $Id: file-detect.el,v 7.1 1997/11/08 07:40:52 morioka Exp $
 ;; Keywords: file detection, install, module
 ;; Status: obsoleted
 
Index: filename.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/filename.el,v
retrieving revision 1.2
diff -u -r1.2 filename.el
--- filename.el	1999/07/23 08:33:23	1.2
+++ filename.el	1999/10/22 05:15:34
@@ -3,7 +3,7 @@
 ;; Copyright (C) 1996,1997 MORIOKA Tomohiko
 
 ;; Author: MORIOKA Tomohiko <morioka@jaist.ac.jp>
-;; Version: $Id: filename.el,v 1.2 1999/07/23 08:33:23 steveb Exp $
+;; Version: $Id: filename.el,v 2.1 1997/11/06 15:50:53 morioka Exp $
 ;; Keywords: file name, string
 
 ;; This file is part of APEL (A Portable Emacs Library).
Index: install.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/install.el,v
retrieving revision 1.3
diff -u -r1.3 install.el
--- install.el	1999/07/23 08:33:23	1.3
+++ install.el	1999/10/22 05:15:34
@@ -28,8 +28,9 @@
 ;; for historical reason, we do (require 'emu) in this file.
 ;; but you should do (require 'emu) explicitly if you use functions and/or
 ;; variables defined in emu module.
-(require 'emu)
-(require 'path-util)			; default-load-path
+;;(require 'emu)
+(require 'poe)		; emacs-major-version, emacs-minor-version
+(require 'path-util)	; default-load-path
 
 ;; verbatim copy of `defun-maybe' from poe.el, and
 ;; `make-directory-internal' and `make-directory' from poe-18.el
Index: mcs-20.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/mcs-20.el,v
retrieving revision 1.4
diff -u -r1.4 mcs-20.el
--- mcs-20.el	1999/07/23 08:33:24	1.4
+++ mcs-20.el	1999/10/22 05:15:34
@@ -44,7 +44,8 @@
 	   (cn-gb	  . cn-gb-2312)
 	   (iso-2022-jp-2 . iso-2022-7bit-ss2)
 	   (tis-620	  . tis620)
-	   (windows-874	  . tis620)
+	   (windows-874	  . tis-620)
+	   (cp874	  . tis-620)
 	   (x-ctext       . ctext)
 	   (unknown       . undecided)
 	   (x-unknown     . undecided)
Index: mcs-xm.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/mcs-xm.el,v
retrieving revision 1.1
diff -u -r1.1 mcs-xm.el
--- mcs-xm.el	1999/03/12 07:30:55	1.1
+++ mcs-xm.el	1999/10/22 05:15:35
@@ -1,6 +1,6 @@
 ;;; mcs-xm.el --- MIME charset implementation for XEmacs-mule
 
-;; Copyright (C) 1997,1998 Free Software Foundation, Inc.
+;; Copyright (C) 1997,1998,1999 Free Software Foundation, Inc.
 
 ;; Author: MORIOKA Tomohiko <morioka@jaist.ac.jp>
 ;; Keywords: emulation, compatibility, Mule
@@ -41,11 +41,15 @@
 
 
 (defcustom mime-charset-decoder-alist
-  '((iso-2022-jp . decode-mime-charset-region-with-iso646-unification)
-    (iso-2022-jp-2 . decode-mime-charset-region-with-iso646-unification)
-    (x-ctext . decode-mime-charset-region-with-iso646-unification)
-    (hz-gb-2312 . decode-mime-charset-region-for-hz)
-    (t . decode-mime-charset-region-default))
+  (let ((alist
+	 '((hz-gb-2312 . decode-mime-charset-region-for-hz)
+	   (t . decode-mime-charset-region-default))))
+    (if (featurep 'utf-2000)
+	alist
+      (list*
+       '(iso-2022-jp . decode-mime-charset-region-with-iso646-unification)
+       '(iso-2022-jp-2 . decode-mime-charset-region-with-iso646-unification)
+       alist)))
   "Alist MIME-charset vs. decoder function."
   :group 'i18n
   :type '(repeat (cons mime-charset function)))
@@ -56,56 +60,58 @@
 	(decode-coding-region start end cs)
       )))
 
-(defcustom mime-iso646-character-unification-alist
-  (eval-when-compile
-    (let (dest
-	  (i 33))
-      (while (< i 92)
-	(setq dest
-	      (cons (cons (char-to-string (make-char 'latin-jisx0201 i))
-			  (format "%c" i))
-		    dest))
-	(setq i (1+ i)))
-      (setq i 93)
-      (while (< i 126)
-	(setq dest
-	      (cons (cons (char-to-string (make-char 'latin-jisx0201 i))
-			  (format "%c" i))
-		    dest))
-	(setq i (1+ i)))
-      (nreverse dest)))
-  "Alist unified string vs. canonical string."
-  :group 'i18n
-  :type '(repeat (cons string string)))
-
-(defcustom mime-unified-character-face nil
-  "*Face of unified character."
-  :group 'i18n
-  :type 'face)
-
-(defcustom mime-character-unification-limit-size 2048
-  "*Limit size to unify characters."
-  :group 'i18n
-  :type 'integer)
-
-(defun decode-mime-charset-region-with-iso646-unification (start end charset
-								 lbt)
-  (decode-mime-charset-region-default start end charset lbt)
-  (if (<= (- end start) mime-character-unification-limit-size)
-      (save-excursion
-	(let ((rest mime-iso646-character-unification-alist))
-	  (while rest
-	    (let ((pair (car rest)))
-	      (goto-char start)
-	      (while (search-forward (car pair) end t)
-		(let ((str (cdr pair)))
-		  (put-text-property 0 (length str)
-				     'face mime-unified-character-face str)
-		  (replace-match str 'fixed-case 'literal)
-		  )
-		))
-	    (setq rest (cdr rest)))))
-    ))
+(unless (featurep 'utf-2000)
+  (defcustom mime-iso646-character-unification-alist
+    (eval-when-compile
+      (let (dest
+	    (i 33))
+	(while (< i 92)
+	  (setq dest
+		(cons (cons (char-to-string (make-char 'latin-jisx0201 i))
+			    (format "%c" i))
+		      dest))
+	  (setq i (1+ i)))
+	(setq i 93)
+	(while (< i 126)
+	  (setq dest
+		(cons (cons (char-to-string (make-char 'latin-jisx0201 i))
+			    (format "%c" i))
+		      dest))
+	  (setq i (1+ i)))
+	(nreverse dest)))
+    "Alist unified string vs. canonical string."
+    :group 'i18n
+    :type '(repeat (cons string string)))
+
+  (defcustom mime-unified-character-face nil
+    "*Face of unified character."
+    :group 'i18n
+    :type 'face)
+
+  (defcustom mime-character-unification-limit-size 2048
+    "*Limit size to unify characters."
+    :group 'i18n
+    :type 'integer)
+
+  (defun decode-mime-charset-region-with-iso646-unification (start end charset
+								   lbt)
+    (decode-mime-charset-region-default start end charset lbt)
+    (if (<= (- end start) mime-character-unification-limit-size)
+	(save-excursion
+	  (let ((rest mime-iso646-character-unification-alist))
+	    (while rest
+	      (let ((pair (car rest)))
+		(goto-char start)
+		(while (search-forward (car pair) end t)
+		  (let ((str (cdr pair)))
+		    (put-text-property 0 (length str)
+				       'face mime-unified-character-face str)
+		    (replace-match str 'fixed-case 'literal)
+		    )
+		  ))
+	      (setq rest (cdr rest)))))
+      ))
+  )
 
 (defun decode-mime-charset-region-for-hz (start end charset lbt)
   (if lbt
@@ -165,6 +171,7 @@
     ((ascii korean-ksc5601)				. euc-kr)
     ((ascii chinese-gb2312)				. gb2312)
     ((ascii chinese-big5-1 chinese-big5-2)		. big5)
+    ((ascii thai-xtis)					. tis-620)
     ((ascii latin-iso8859-1 greek-iso8859-7
 	    latin-jisx0201 japanese-jisx0208-1978
 	    chinese-gb2312 japanese-jisx0208
Index: path-util.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/path-util.el,v
retrieving revision 1.2
diff -u -r1.2 path-util.el
--- path-util.el	1999/05/13 16:41:13	1.2
+++ path-util.el	1999/10/22 05:15:36
@@ -1,9 +1,8 @@
 ;;; path-util.el --- Emacs Lisp file detection utility
 
-;; Copyright (C) 1996,1997 Free Software Foundation, Inc.
+;; Copyright (C) 1996,1997,1999 Free Software Foundation, Inc.
 
-;; Author: MORIOKA Tomohiko <morioka@jaist.ac.jp>
-;; Version: $Id: path-util.el,v 1.2 1999/05/13 16:41:13 steveb Exp $
+;; Author: MORIOKA Tomohiko <tomo@m17n.org>
 ;; Keywords: file detection, install, module
 
 ;; This file is part of APEL (A Portable Emacs Library).
@@ -25,6 +24,8 @@
 
 ;;; Code:
 
+(require 'poe)
+
 (defvar default-load-path load-path
   "*Base of `load-path'.
 It is used as default value of target path to search file or
@@ -138,28 +139,59 @@
   (or suffixes
       (setq suffixes exec-suffix-list)
       )
-  (catch 'tag
-    (while paths
-      (let ((stem (expand-file-name file (car paths)))
-	    (sufs suffixes)
+  (let (files)
+    (catch 'tag
+      (while suffixes
+	(let ((suf (car suffixes)))
+	  (if (and (not (string= suf ""))
+		   (string-match (concat (regexp-quote suf) "$") file))
+	      (progn
+		(setq files (list file))
+		(throw 'tag nil)
+		)
+	    (setq files (cons (concat file suf) files))
 	    )
-	(while sufs
-	  (let ((file (concat stem (car sufs))))
-	    (if (file-exists-p file)
+	  (setq suffixes (cdr suffixes))
+	  )))
+    (setq files (nreverse files))
+    (catch 'tag
+      (while paths
+	(let ((path (car paths))
+	      (files files)
+	      )
+	  (while files
+	    (setq file (expand-file-name (car files) path))
+	    (if (file-executable-p file)
 		(throw 'tag file)
-	      ))
-	  (setq sufs (cdr sufs))
-	  ))
-      (setq paths (cdr paths))
-      )))
+	      )
+	    (setq files (cdr files))
+	    )
+	  (setq paths (cdr paths))
+	  )))))
 
 ;;;###autoload
 (defun module-installed-p (module &optional paths)
   "Return t if module is provided or exists in PATHS.
 If PATHS is omitted, `load-path' is used."
   (or (featurep module)
-      (exec-installed-p (symbol-name module) load-path '(".elc" ".el"))
-      ))
+      (let ((file (symbol-name module)))
+	(or paths
+	    (setq paths load-path)
+	    )
+	(catch 'tag
+	  (while paths
+	    (let ((stem (expand-file-name file (car paths)))
+		  (sufs '(".elc" ".el"))
+		  )
+	      (while sufs
+		(let ((file (concat stem (car sufs))))
+		  (if (file-exists-p file)
+		      (throw 'tag file)
+		    ))
+		(setq sufs (cdr sufs))
+		))
+	    (setq paths (cdr paths))
+	    )))))
 
 
 ;;; @ end
Index: pces.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/pces.el,v
retrieving revision 1.1
diff -u -r1.1 pces.el
--- pces.el	1999/07/23 08:33:25	1.1
+++ pces.el	1999/10/22 05:15:38
@@ -30,10 +30,11 @@
   (unless (fboundp 'open-network-stream)
     (require 'tcp)))
 
-(cond ((and (featurep 'xemacs)
-	    (featurep 'file-coding))
-       (require 'pces-xfc)
-       )
+(cond ((featurep 'xemacs)
+       (if (or (featurep 'mule) (featurep 'file-coding))
+	   (require 'pces-xfc)
+	 (require 'pces-raw)
+	 ))
       ((featurep 'mule)
        (if (>= emacs-major-version 20)
 	   (require 'pces-e20)
Index: poe.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/poe.el,v
retrieving revision 1.3
diff -u -r1.3 poe.el
--- poe.el	1999/07/23 08:33:25	1.3
+++ poe.el	1999/10/22 05:15:40
@@ -215,6 +215,17 @@
 (def-edebug-spec defun-maybe defun)
 (def-edebug-spec defmacro-maybe defmacro)
 (def-edebug-spec defsubst-maybe defun)
+(def-edebug-spec defun-maybe-cond
+  (&define name lambda-list
+	   [&optional stringp]
+	   [&rest ([&not eval] [&rest sexp])]
+	   [&optional (eval [&optional ("interactive" interactive)] def-body)]
+	   &rest (&rest sexp)))
+(def-edebug-spec defmacro-maybe-cond
+  (&define name lambda-list
+	   [&rest ([&not eval] [&rest sexp])]
+	   [&optional (eval def-body)]
+	   &rest (&rest sexp)))
 
 ;;; Emacs 20.1 emulation
 
@@ -287,12 +298,14 @@
 (defun-maybe rassoc (key list)
   "Return non-nil if KEY is `equal' to the cdr of an element of LIST.
 The value is actually the element of LIST whose cdr equals KEY.
+Elements of LIST that are not conses are ignored.
 \[Emacs 19.29 emulating function]"
   (catch 'found
     (while list
-      (if (equal (cdr (car list)) key)
-	  (throw 'found (car list)))
-      (setq list (cdr list)))))
+      (cond ((not (consp (car list))))
+	    ((equal (cdr (car list)) key)
+	     (throw 'found (car list)) ))
+      (setq list (cdr list)) )))
 
 ;; imported from emacs-19.34/lisp/files.el.
 (defun-maybe file-name-sans-extension (filename)
@@ -365,6 +378,28 @@
 	(list 'unwind-protect
 	      (cons 'progn body)
 	      (list 'select-window 'save-selected-window-window))))
+
+(defun-maybe-cond convert-standard-filename (filename)
+  "Convert a standard file's name to something suitable for the current OS.
+This function's standard definition is trivial; it just returns the argument.
+However, on some systems, the function is redefined
+with a definition that really does change some file names.
+Under `windows-nt' or `ms-dos', it refers `filename-replacement-alist' and
+`filename-limit-length' for the basic filename and each parent directory name.
+\[Emacs 19.31 emulating function]"
+  ((memq system-type '(windows-nt ms-dos))
+   (require 'filename)
+   (let* ((names (split-string filename "/"))
+	  (drive-name (car names))
+	  (filter (function (lambda (string)
+			      (filename-maybe-truncate-by-size
+			       (filename-special-filter string))))))
+     (cond ((eq 1 (length names))
+	    (funcall filter drive-name))
+	   ((string-match "^[^/]:$" drive-name)
+	    (concat drive-name "/" (mapconcat filter (cdr names) "/")))
+	   (t (mapconcat filter names "/")))))
+  (t filename))
 
 
 ;;; @ Emacs 20.1 emulation
Index: richtext.el
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-packages/libs/apel/richtext.el,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 richtext.el
--- richtext.el	1998/01/14 06:31:32	1.1.1.1
+++ richtext.el	1999/10/22 05:15:41
@@ -4,7 +4,7 @@
 
 ;; Author: MORIOKA Tomohiko <morioka@jaist.ac.jp>
 ;; Created: 1995/7/15
-;; Version: $Id: richtext.el,v 1.1.1.1 1998/01/14 06:31:32 steve Exp $
+;; Version: $Id: richtext.el,v 3.6 1997/06/28 17:58:34 morioka Exp $
 ;; Keywords: wp, faces, MIME, multimedia
 
 ;; This file is not part of GNU Emacs yet.
cvs server: cannot find std11-parse.el
cvs server: cannot find std11.el