Index: lisp/faces.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/faces.el,v
retrieving revision 1.25
diff -u -w -u -w -r1.25 faces.el
--- lisp/faces.el	2001/05/04 22:42:01	1.25
+++ lisp/faces.el	2001/12/13 04:56:29
@@ -1761,96 +1761,62 @@
 ;; the first non-stream device.
 
 (set-face-background 'text-cursor
-		     '(((x default) . "Red3")
-		       ((mswindows default) . "Red3"))
+		     '(((win default) . "Red3"))
 		     'global)
 
 ;; some older X servers don't recognize "darkseagreen2"
 (set-face-background 'highlight
-		     '(((x default color) . "darkseagreen2")
-		       ((x default color) . "green")
-		       ((x default grayscale) . "gray53")
-		       ((mswindows default color) . "darkseagreen2")
-		       ((mswindows default color) . "green")
-		       ((mswindows default grayscale) . "gray53"))
+		     '(((win default color) . "darkseagreen2")
+		       ((win default color) . "green")
+		       ((win default grayscale) . "gray53"))
 		     'global)
 (set-face-background-pixmap 'highlight
-			    '(((x default mono) . "gray1")
-;; 			      ((gtk default mono) . "gray1")
-			      ((mswindows default mono) . "gray1"))
+			    '(((win default mono) . "gray1"))
 			    'global)
 
 (set-face-background 'zmacs-region
-		     '(((x default color) . "gray65")
-		       ((x default grayscale) . "gray65")
-		       ((mswindows default color) . "gray65")
-		       ((mswindows default grayscale) . "gray65"))
+		     '(((win default color) . "gray65")
+		       ((win default grayscale) . "gray65"))
 		     'global)
 (set-face-background-pixmap 'zmacs-region
-			    '(((x default mono) . "gray3")
-;; 			      ((gtk default mono) . "gray3")
-			      ((mswindows default mono) . "gray3"))
+			    '(((win default mono) . "gray3"))
 			    'global)
 
 (set-face-background 'list-mode-item-selected
-		     '(((x default color) . "gray68")
-		       ((x default grayscale) . "gray68")
-		       ((x default mono) . [default foreground])
-;; 		       ((gtk default color) . "gray68")
-;; 		       ((gtk default grayscale) . "gray68")
-;; 		       ((gtk default mono) . [default foreground])
-		       ((mswindows default color) . "gray68")
-		       ((mswindows default grayscale) . "gray68")
-		       ((mswindows default mono) . [default foreground]))
+		     '(((win default color) . "gray68")
+		       ((win default grayscale) . "gray68")
+		       ((win default mono) . [default foreground]))
 		     'global)
 (set-face-foreground 'list-mode-item-selected
-		     '(((x default mono) . [default background])
-		       ((mswindows default mono) . [default background]))
+		     '(((win default mono) . [default background]))
 		     'global)
 
 (set-face-background 'primary-selection
-		     '(((x default color) . "gray65")
-		       ((x default grayscale) . "gray65")
-		       ((mswindows default color) . "gray65")
-		       ((mswindows default grayscale) . "gray65"))
+		     '(((win default color) . "gray65")
+		       ((win default grayscale) . "gray65"))
 		     'global)
 (set-face-background-pixmap 'primary-selection
-			    '(((x default mono) . "gray3")
-			      ;;((gtk default mono) . "gray3")
-			      ((mswindows default mono) . "gray3"))
+			    '(((win default mono) . "gray3"))
 			    'global)
 
 (set-face-background 'secondary-selection
-		     '(((x default color) . "paleturquoise")
-		       ((x default color) . "green")
-		       ((x default grayscale) . "gray53")
-		       ;;((gtk default color) . "paleturquoise")
-		       ;;((gtk default color) . "green")
-		       ;;((gtk default grayscale) . "gray53")
-		       ((mswindows default color) . "paleturquoise")
-		       ((mswindows default color) . "green")
-		       ((mswindows default grayscale) . "gray53"))
+		     '(((win default color) . "paleturquoise")
+		       ((win default color) . "green")
+		       ((win default grayscale) . "gray53"))
 		     'global)
 (set-face-background-pixmap 'secondary-selection
-			    '(((x default mono) . "gray1")
-			      ;;((gtk default mono) . "gray1")
-			      ((mswindows default mono) . "gray1"))
+			    '(((win default mono) . "gray1"))
 			    'global)
 
 (set-face-background 'isearch
-		     '(((x default color) . "paleturquoise")
-		       ((x default color) . "green")
-		       ;;((gtk default color) . "paleturquoise")
-		       ;;((gtk default color) . "green")
-		       ((mswindows default color) . "paleturquoise")
-		       ((mswindows default color) . "green"))
+		     '(((win default color) . "paleturquoise")
+		       ((win default color) . "green"))
 		     'global)
 
 ;; #### This should really, I mean *really*, be converted to some form
 ;; of `defface' one day.
 (set-face-foreground 'isearch-secondary
-		     '(((x default color) . "red3")
-		       ((mswindows default color) . "red3"))
+		     '(((win default color) . "red3"))
 		     'global)
 
 ;; Define some logical color names to be used when reading the pixmap files.
Index: lisp/gtk-faces.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/gtk-faces.el,v
retrieving revision 1.3
diff -u -w -u -w -r1.3 gtk-faces.el
--- lisp/gtk-faces.el	2001/05/04 22:42:04	1.3
+++ lisp/gtk-faces.el	2001/12/13 04:56:29
@@ -42,15 +42,6 @@
    gtk-font-selection-dialog-cancel-button gtk-widget-show-all
    gtk-main))
 
-(defun gtk-init-find-device ()
-  (let ((dev nil)
-	(devices (device-list)))
-    (while (and (not dev) devices)
-      (if (eq (device-type (car devices)) 'gtk)
-	  (setq dev (car devices)))
-      (setq devices (cdr devices)))
-    dev))
-
 ;;; gtk-init-device-faces is responsible for initializing default
 ;;; values for faces on a newly created device.
 ;;;
@@ -58,29 +49,8 @@
   ;;
   ;; If the "default" face didn't have a font specified, try to pick one.
   ;;
-  (if (not (eq (device-type device) 'gtk))
-      nil
-    (gtk-init-pointers)
-    '(let* ((style (gtk-style-info device))
-	   ;;(normal 0)			; GTK_STATE_NORMAL
-	   ;;(active 1)			; GTK_STATE_ACTIVE
-	   (prelight 2)			; GTK_STATE_PRELIGHT
-	   (selected 3)			; GTK_STATE_SELECTED
-	   ;;(insensitive 4)		; GTK_STATE_INSENSITIVE
-	   )
-      (set-face-foreground 'highlight
-			   (nth prelight (plist-get style 'text))
-			   device)
-      (set-face-background 'highlight
-			   (nth prelight (plist-get style 'background))
-			   device)
-      (set-face-foreground 'zmacs-region
-			   (nth selected (plist-get style 'text))
-			   device)
-      (set-face-background 'zmacs-region
-			   (nth selected (plist-get style 'background))
-			   device))
-    (set-face-background 'text-cursor "red3" device)))
+  (when (eq (device-type device) 'gtk)
+    (gtk-init-pointers)))
 
 ;;; This is called from `init-frame-faces', which is called from
 ;;; init_frame_faces() which is called from Fmake_frame(), to perform
@@ -94,9 +64,9 @@
 ;;; specified.
 ;;;
 (defun gtk-init-global-faces ()
-  (let* ((dev (gtk-init-find-device))
+  (let* ((dev nil)
 	 (default-font (or (face-font 'default 'global)
-			   ;(plist-get (gtk-style-info dev) 'font)
+			   ;;(plist-get (gtk-style-info dev) 'font)
 			   "-*-courier-medium-r-*-*-*-120-*-*-*-*-iso8859-*"))
 	 (italic-font (or (gtk-make-font-italic default-font dev) default-font))
 	 (bold-font (or (gtk-make-font-bold default-font dev) default-font))
Index: lisp/gui.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/gui.el,v
retrieving revision 1.6
diff -u -w -u -w -r1.6 gui.el
--- lisp/gui.el	2001/04/12 18:21:26	1.6
+++ lisp/gui.el	2001/12/13 04:56:29
@@ -89,10 +89,8 @@
 (if (not (face-differs-from-default-p 'gui-button-face))
     (progn
       (set-face-reverse-p 'gui-button-face t)
-      (set-face-background 'gui-button-face '(((x color) . "grey75")
-					      ((mswindows color) . "grey75")))
-      (set-face-foreground 'gui-button-face '(((x color) . "black")
-					      ((mswindows color) . "black")))))
+      (set-face-background 'gui-button-face '(((win color) . "grey75")))
+      (set-face-foreground 'gui-button-face '(((win color) . "black")))))
 
 
 (defun gui-button-action (instance action user-data)